/* 変数型の定義 */
typedef enum {
  STP = 0,
  STR,
  ROT,
  LNT,
  LNT_RS,
  ARM,
  ARM_PID
} run_state_t;

typedef struct {
  unsigned char val[7];
} serial_data_t;

typedef struct {
  unsigned char val[6];
} middle_data_t;

typedef struct {
  signed short val[3];
} command_data_t;

/* ピン配置 */
#define PIN_ENC_A_L  2//左エンコーダA相
#define PIN_ENC_A_R  3//右エンコーダA相
#define PIN_ENC_B_L  4//左エンコーダB相
#define PIN_ENC_B_R  7//右エンコーダB相
#define PIN_DIR_R    8//右モータ(DIR)
#define PIN_PWM_R    5//右モータ(PWM)
#define PIN_SM      10//サーボモータ(PWM)
#define PIN_PWM_L    6//左モータ(PWM)
#define PIN_DIR_L    9//左モータ(DIR)
#define PIN_ARM_DIR 11//アーム(DIR)
#define PIN_ARM_PWM 12//アーム(PWM)
#define TX3         14//URT送信
#define RX3         15//URT受信
#define PIN_LED     23//状態表示LED
#define PIN_LED_F   42//アーム先端LED
#define PIN_BATT    29//電源ボタン
#define PIN_VOLT    A0//電圧監視
#define PIN_PSE     A1//圧力センサ
#define PIN_CHR     A2//可変抵抗信号
#define PIN_FRF_0   A3//フォトリフレクタ0
#define PIN_FRF_1   A4//フォトリフレクタ1
#define PIN_FRF_2   A5//フォトリフレクタ2
#define PIN_FRF_3   A6//フォトリフレクタ3
#define PIN_FRF_4   A7//フォトリフレクタ4
#define PIN_FRF_5   A8//フォトリフレクタ5
#define PIN_FRF_6   A9//フォトリフレクタ6


#define WAIT 0//blue
#define JUDGE 1//green
#define INSPEC 2//purple
#define WASH 3//shian
#define HOMING 4//blue_blink

/* パラメータ */
// 動作周期 [ms]
#define T_CTRL 10

// タイヤ半径 [cm] 3.2
#define R_TIRE     4.2//4.387 

// タイヤ間隔 [cm] 25.0
#define D_TIRE    31.6

// エンコーダ分解能 (A相立上り/立下りを利用するため2倍)
#define ENC_RANGE (13*2)

// ギア比　（該当するものを選択）
// 1/14 ギア  13 and 212/289
#define GEAR_RATIO 13.734
// 1/19 ギア  19 and 38/187
//#define GEAR_RATIO 19.203
// 1/27 ギア  26 and 103/121
//#define GEAR_RATIO 27.851

// 左タイヤに対する右タイヤの回転比
#define L_R_RATIO  0.99
// バッテリ入力の分圧比
#define V_RATIO 0.5

int judge = 0;
//右モータのpwm値
int pwm_r = 0;
//左モータのpwm値
int pwm_l = 0;
//アーム用モータのpwm値
int pwm_a = 0;
//アーム用モータ指令値


//圧力センサについて
double pres_val = 0.0;
double pres_val_ll = 40.0;
double pres_val_ul = 50.0;

int LNT_frag = 0;
