const int ispeed = 80;//機体の進む速度(pwm値)
float fP_gain = 0.5;//pゲイン0.5
float fD_gain = 1.0;//ｄゲイン10

//int iwhite = 800;
//int iblack = 990;
int ithreshold[7] = { 
  880,900,894,908,964,889,953}; //ライントレースの閾値(iwhite + iblack) //871,912,882,939,935,903,919;;;871,898,917,905,960,914,928
int ierr[7];//閾値と今のフォトリフレクタの値の差
//int iberr[2] = {0, 0};// 黒の値と今のフォトリフレクタの値の差
int inow[7] = {
  0, 0, 0, 0, 0, 0, 0};//フォトリフレクタから得た今の値
int iold[7] = {
  0, 0, 0, 0, 0, 0, 0};//ひとつ前のierrの値
//int ibold[2] = {0, 0};//ひとつ前のiberrの差

double dist_l, dist_r, angle_current, dist_current;//ロータリ―エンコーダで読んだ距離の変数。ライントレースの終了について判断するために使う。

int ierrstop = 0; //エラーが起きた時、モーターを止めて状態をストップにする為の変数
int istop_linetrace = 0; //コースを走り切ったときにライントレースを終える為の変数

float fPID_P_R = 0; //Pゲインの右モータに干渉する値
float fPID_P_L = 0; //Pゲインの左モータに干渉する値
float fPID_D_R = 0; //Dゲインの右モータに干渉する値
float fPID_D_L = 0; //Dゲインの左モータに干渉する値

float fDELTA_T = 0.1; //フォトリフレクタで値を読む頻度[msec]0.1

int iException[7] = {
  0, 0, 0, 0, 0, 0, 0}; //白線を踏んでいるフォトリフレクタの数をカウントするために使う。,,,例外(白線を踏んでいるフォトリフレクタが1つ未満)を処理するための変数
int iExc_pt = 0;//白線を踏んでいるフォトリフレクタの数によって数が増減する。踏んでいない数をカウントしている

static int iStep = 0;

static int imode_str = 0;//直進モード
static int imode_turn = 0;//左折,右折モード
static int imode_restart = 0;//復帰モード

bool bcarib_flag = 1;//キャリブレーションでつかう変数たち
int inow_max[7] = {
  0, 0, 0, 0, 0, 0, 0};
int inow_min[7] = {
  0, 0, 0, 0, 0, 0, 0};

bool bcorrection_frag = 0;


/*
  void loop() {
 test_line();
 Serial.println();
 delay(1);
 }
 */


void linetrace_open() {
  //Serial.begin(115200);
  pinMode(PIN_FRF_0, INPUT);
  pinMode(PIN_FRF_1, INPUT);
  pinMode(PIN_FRF_2, INPUT);
  pinMode(PIN_FRF_3, INPUT);
  pinMode(PIN_FRF_4, INPUT);
  pinMode(PIN_FRF_5, INPUT);
  pinMode(PIN_FRF_6, INPUT);
  //  pinMode(PIN_PWM_L, OUTPUT);
  //  pinMode(PIN_PWM_R, OUTPUT);
}

void photo_calibration() { //フォトリフレクタのキャリブレーション

  //    distance_get(&dist_l, &dist_r);
  //    angle_current  = -(dist_l - dist_r) / D_TIRE * 180.0 / PI;
  //    pwm_r = -60;
  //    pwm_l = -pwm_r;
  //    motor_set(pwm_l, pwm_r);

  photoreflector();//フォトリフレクタの値をとる
  if (bcarib_flag == 1) {//最初に比較対象を作るfor文
    for (int i = 0; i < 7; i++) {
      inow_max[i] = inow[i];
      inow_min[i] = inow[i];
    }
    bcarib_flag = 0;
  }

  for (int i = 0; i < 7; i++) {
    if (inow[i] > inow_max[i]) {
      inow_max[i] = inow[i];
    }
    if (inow[i] < inow_min[i]) {
      inow_min[i] = inow[i];
    }
  }

  //キャリブレーションで1周させるための部分
  for (int i = 0; i < 7; i++) {//閾値の設定
    ithreshold[i] = (inow_max[i] + inow_min[i]) / 2;
  }
}

void photoreflector() { //フォトリフレクタの値を読んで、閾値との差を計算する
  iExc_pt = 0;//カウントのりせっと

  inow[0] = analogRead(PIN_FRF_0);
  inow[1] = analogRead(PIN_FRF_1);
  inow[2] = analogRead(PIN_FRF_2);
  inow[3] = analogRead(PIN_FRF_3);
  inow[4] = analogRead(PIN_FRF_4);
  inow[5] = analogRead(PIN_FRF_5);
  inow[6] = analogRead(PIN_FRF_6);
  for (int i = 0; i < 7; i++) {
    iException[i] = 0; //カウントのりせっと
    iold[i] = ierr[i];
    ierr[i] = ithreshold[i] - inow[i];//白線を踏んでいるかどうかを確認する。閾値との差を計算する//ithとinowを逆にした11/29
    if (ierr[i] <= 0) { //ierrが0未満だったら(白線を踏んでいなかったら)
      iException[i] = 1;
    }
    iExc_pt += iException[i];
  }
  //ibold[0] = iberr[0];
  //ibold[1] = iberr[1];
  //iberr[0] = inow[3] - iblack;
  //iberr[1] = inow[4] - iblack;
}

void linetrace_execute() {




  if (iExc_pt == 7) {
    iStep = 0;//一個も踏んでいない場合。復帰動作中に起こりうる。後退する。
  }
  else if (iExc_pt == 6) { //白線を踏んでいるフォトリフレクタが1つなら
    iStep = 1;
    //仮の動作案として、回転してフォトリフレクタが複数個白線を踏む位置を探すorエラーとして動作を止める
  }
  else if (iExc_pt == 5) { //白線を踏んでいるフォトリフレクタが2つ
    iStep = 2;
  }
  else if (iExc_pt == 4) { //白線を踏んでいるフォトリフレクタが3つ
    iStep = 3;
  }
  else if (iExc_pt == 3) { //白線を踏んでいるフォトリフレクタが4つ
    iStep = 4;
  }
  else if (iExc_pt == 2) { //白線を踏んでいるフォトリフレクタが5つ
    iStep = 5;
  }
  else if (iExc_pt == 1) {
    iStep = 6;
  }
  else { //こうなったらフォトリフレクタがおかしい?左折部分でめちゃくちゃ噛み合ったら起こりうる?
    ierrstop = 1;
    imode_str = 0;
    imode_restart = 0;
    imode_turn = 0;
  }


  switch (iStep) {
  case 0://一個も白線を踏んでないとき。復帰動作中に起こるかも。起こったら後退させる。
    imode_restart = 2;
    imode_str = 0;
    imode_turn = 0;
    ierrstop = 0;
    break;



  case 1://例外処理のための動作を行う。右回転させて、1回転して何も起こらなかったら、止める?
    // distance_get(&dist_l, &dist_r);
    //angle_current  = -(dist_l - dist_r) / D_TIRE * 180.0 / PI;
    pwm_r = -60;
    pwm_l = -pwm_r;
    /*
        if (angle_current > 360) {
     pwm_r = 0;
     pwm_l = 0; //エラーとか画面に出す？
     ierrstop = 1;
     imode_str = 0;
     imode_restart = 0;
     imode_turn = 0;
     }
     */
    break;

  case 2:
    if (iException[1] == 0 && iException[2] == 0) { //復帰動作中に起こる想定,機体が下がりすぎ
      imode_str = 0;
      imode_restart = 1; //前進:1
      imode_turn = 0;
      ierrstop = 0;
    }
    else if (iException[5] == 0 && iException[6] == 0) { //復帰動作中に起こる想定,もっと下がる必要がある
      imode_str = 0;
      imode_restart = 2; //後退:2
      imode_turn = 0;
      ierrstop = 0;
    }
    else if (iException[0] == 0 && iException[3] == 0) { //復帰動作中に起こると予想,右モータのpwm値を上げてより戻るようにする
      imode_str = 0;
      imode_restart = 2; //後退:2
      imode_turn = 0;
      ierrstop = 0;
    }
    else if (iException[0] == 0 && iException[4] == 0) { //復帰動作中に起こると予想,左モータのpwm値を上げてより戻るようにする
      imode_str = 0;
      imode_restart = 2; //後退:2
      imode_turn = 0;
      ierrstop = 0;
    }
    else {
      imode_str = 1;
      imode_restart = 0;
      imode_turn = 0;
      ierrstop = 0;
    }
    break;

  case 3:
    if (iException[0] == 0 && iException[3] == 0 && iException[4] == 0) { //復帰動作中に起こる想定,これを踏んでいたら右折
      imode_str = 0;
      imode_restart = 0;
      imode_turn = 1; //右回転:1
      ierrstop = 0;
      //motor_set(0, 0);
    }
    else if (iException[0] == 0 && iException[3] == 0 && iException[5] == 0) { //コースの左折部分で起こる想定,これを踏んでいたら左折と判断

      imode_str = 0;
      imode_turn = 2; //左折:2
      imode_restart = 0;
      ierrstop = 0;
      delay(10);
      motor_set(0, 0);
    }
    else if (iException[0] == 0 && iException[3] == 0 && iException[6] == 0) { //コースの左折部分で起こる想定,これを踏んでいたら左折と判断

      imode_str = 0;
      imode_turn = 2; //左折:2
      imode_restart = 0;
      ierrstop = 0;
      delay(10);
      motor_set(0, 0);
    }
    else {
      imode_str = 1;
      imode_restart = 0;
      imode_turn = 0;
      ierrstop = 0;
    }

    break;

  case 4:
    if (iException[0] == 0 && iException[1] == 0 && iException[3] == 0 && iException[4] == 0) { //復帰動作中に起こると予想,もっと後退させる必要がある.右モータのpwm値を上げてより戻るようにする
      imode_str = 0;
      imode_restart = 2; //後退:2
      imode_turn = 0;
      ierrstop = 0;
    }
    else if (iException[0] == 0 && iException[2] == 0 && iException[3] == 0 && iException[4] == 0) { //復帰動作中に起こると予想,もっと後退させる必要がある.左モータのpwm値を上げてより戻るようにする
      imode_str = 0;
      imode_restart = 2; //後退:2
      imode_turn = 0;
      ierrstop = 0;
    }
    else {
      imode_str = 1;
      imode_restart = 0;
      imode_turn = 0;
      ierrstop = 0;
    }
    if (iException[0] == 0 && iException[3] == 0 && iException[5] == 0) { //コースの左折部分で起こる想定,これを踏んでいたら左折と判断

      imode_str = 0;
      imode_restart = 0;
      imode_turn = 2; //左折:2
      ierrstop = 0;
      delay(10);
      motor_set(0, 0);
    } 
    else if (iException[0] == 0 && iException[3] == 0 && iException[6] == 0) { //コースの左折部分で起こる想定,これを踏んでいたら左折と判断

      imode_str = 0;
      imode_restart = 0;
      imode_turn = 2; //左折:2
      ierrstop = 0;
      delay(10);
      motor_set(0, 0);
    } 
    else if (iException[0] == 0 && iException[4] == 0 && iException[5] == 0) { //コースの右折部分で起こる想定,これを踏んでいたら右折と判断
      imode_str = 0;
      imode_restart = 0;
      imode_turn = 3; //右折:3
      ierrstop = 0;
      motor_set(0, 0);
    } 
    else if (iException[0] == 0 && iException[4] == 0 && iException[6] == 0) { //コースの右折部分で起こる想定,これを踏んでいたら右折と判断
      imode_str = 0;
      imode_restart = 0;
      imode_turn = 3; //右折:3
      ierrstop = 0;
      motor_set(0, 0);
    }
    break;

  case 5:
    if (iException[0] == 0 && iException[1] == 0 && iException[2] == 0 && iException[3] == 0 && iException[4] == 0) {
      imode_str = 0;
      imode_restart = 1; //前進:1
      imode_turn = 0;
      ierrstop = 0;
    }
    else {
      imode_str = 1;
      imode_restart = 0;
      imode_turn = 0;
      ierrstop = 0;
    }

    if (iException[0] == 0 && iException[3] == 0 && iException[5] == 0) { //コースの左折部分で起こる想定,これを踏んでいたら左折と判断

      imode_str = 0;
      imode_restart = 0;
      imode_turn = 2; //左折:2
      ierrstop = 0;
      delay(10);
      motor_set(0, 0);
    } 
    else if (iException[0] == 0 && iException[3] == 0 && iException[6] == 0) { //コースの左折部分で起こる想定,これを踏んでいたら左折と判断

      imode_str = 0;
      imode_restart = 0;
      imode_turn = 2; //左折:2
      ierrstop = 0;
      delay(10);
      motor_set(0, 0);
    } 
    else if (iException[0] == 0 && iException[4] == 0 && iException[5] == 0) { //コースの右折部分で起こる想定,これを踏んでいたら右折と判断
      imode_str = 0;
      imode_restart = 0;
      imode_turn = 3; //右折:3
      ierrstop = 0;
      motor_set(0, 0);
    } 
    else if (iException[0] == 0 && iException[4] == 0 && iException[6] == 0) { //コースの右折部分で起こる想定,これを踏んでいたら右折と判断
      imode_str = 0;
      imode_restart = 0;
      imode_turn = 3; //右折:3
      ierrstop = 0;
      motor_set(0, 0);
    }
    break;

  case 6:
    if (iException[0] == 0 && iException[3] == 0 && iException[5] == 0) { //コースの左折部分で起こる想定,これを踏んでいたら左折と判断

      imode_str = 0;
      imode_restart = 0;
      imode_turn = 2; //左折:2
      ierrstop = 0;
      delay(10);
      motor_set(0, 0);
    } 
    else if (iException[0] == 0 && iException[3] == 0 && iException[6] == 0) { //コースの左折部分で起こる想定,これを踏んでいたら左折と判断

      imode_str = 0;
      imode_restart = 0;
      imode_turn = 2; //左折:2
      ierrstop = 0;
      delay(10);
      motor_set(0, 0);
    } 
    else if (iException[0] == 0 && iException[4] == 0 && iException[5] == 0) { //コースの右折部分で起こる想定,これを踏んでいたら右折と判断
      imode_str = 0;
      imode_restart = 0;
      imode_turn = 3; //右折:3
      ierrstop = 0;
      motor_set(0, 0);
    } 
    else if (iException[0] == 0 && iException[4] == 0 && iException[6] == 0) { //コースの右折部分で起こる想定,これを踏んでいたら右折と判断
      imode_str = 0;
      imode_restart = 0;
      imode_turn = 3; //右折:3
      ierrstop = 0;
      motor_set(0, 0);
    } 
    else {
      //フォトリフレクタがおかしくなってる
      ierrstop = 1;
      imode_str = 0;
      imode_restart = 0;
      imode_turn = 0;
    }
    break;

  default://どう考えてもフォトリフレクタがおかしくなってるので、そのときの動作をここに書く
    ierrstop = 1;
    imode_str = 0;
    imode_restart = 0;
    imode_turn = 0;
    break;
  }



  switch (imode_str) { //直進？動作のスイッチケース文
  case 1:
    //PD制御でライントレースする(errにマイナス付けた12/08)
    fPID_P_R = fP_gain * ((ierr[2] + ierr[6]))/2; //2,4のフォトリフレクタの値をつかう(ierr[2] + ierr[6])

    if (iException[4] = 0) {  //白線を4番のフォトリフレクタが踏んだら
      fPID_P_R = (fPID_P_R + 2 * fP_gain * (-ierr[4])) / 3.57;    //２倍してるけど、フォトリフレクタの位置が変わってるので、数字が変わる
    }

    fPID_P_L = fP_gain * ((ierr[1] + ierr[5]))/2; //1,3のフォトリフレクタの値をつかう(ierr[1] + ierr[5])

    if (iException[3] = 0) { //白線を3番のフォトリフレクタが踏んだら  ierr[3] > ithreshild
      fPID_P_L = (fPID_P_L + 2 * fP_gain * (-ierr[3])) / 3.57;
    }

    fPID_D_R = (fD_gain * ((ierr[2] - iold[2]) + (ierr[6] - iold[6])) * fDELTA_T)/2; //((ierr[2] - iold[2]) + (ierr[6] - iold[6]))

    if (iException[3] = 0) {
      fPID_D_R = (fPID_D_R + 2 * fD_gain * (-ierr[3] - iold[3]) / fDELTA_T) / 3; //1,3のフォトリフレクタの値をつかう
    }

    fPID_D_L = (fD_gain * ((ierr[1] - iold[1]) + (ierr[5] - iold[5])) * fDELTA_T)/2; //((ierr[1] - iold[1]) + (ierr[5] - iold[5]))

    if (iException[4] = 0) {
      fPID_D_L = (fPID_D_L + 2 * fD_gain * (-ierr[4] - iold[4]) / fDELTA_T) / 3; //2,4のフォトリフレクタの値をつかう
    }

    if (fPID_P_R > 0) {//<を逆にした
      fPID_P_R = 0;
    }
    if (fPID_D_R > 0) {//<を逆にした
      fPID_D_R = 0;
    }
    if (fPID_P_L > 0) {//<を逆にした
      fPID_P_L = 0;
    }
    if (fPID_D_L > 0) {//<を逆にした
      fPID_D_L = 0;
    }
    pwm_r = ispeed - fPID_P_L - fPID_D_L;//右モータのPWM値(ispeed - fPID_P_R - fPID_D_R)(白線)+,-,-...+++に変える? rとl逆にした12/08
    pwm_l = ispeed - fPID_P_R - fPID_D_R;//左モータのPWM値(ispeed - fPID_P_L - fPID_D_L)(白線)+,-,-...+++に変える?
    if (pwm_r >= 100) {
      pwm_r = 100;
    }
    if (pwm_l >= 100) {
      pwm_l = 100;
    }

    if (pwm_r <= 50) {
      pwm_r = 50;
    }
    if (pwm_l <= 50) {
      pwm_l = 50;
    }
    break;


  default://modeが該当しない
    break;
  }


  switch (imode_restart) { //復帰動作に関するスイッチケース文
    //delay(50);
  case 1://前進して位置を調整する
    //      for (int i = 1; i < 3; i++) { //白→白を保つために白(ierrが正)だったら零にする
    //        if (ierr[i] > 0) {
    //          ierr[i] = 0;
    //          iold[i] = 0;
    //        }
    //      }
    fPID_P_R = fP_gain * ierr[4]; //4,6,0のフォトリフレクタの値をつかう@(fP_gain * ierr[4] + fP_gain * ierr[0])/2.0
    if (ierr[6] > 0) {
      fPID_P_R = (fPID_P_R + fP_gain * ierr[6]) / 2.0;
    }
    fPID_P_L = fP_gain * ierr[3]; //3,5,0のフォトリフレクタの値をつかう@(fP_gain * ierr[3] + fP_gain * ierr[0])/2.0
    if (ierr[5] > 0) {
      fPID_P_R = (fPID_P_R + fP_gain * ierr[5]) / 2.0;
    }
    fPID_D_R = (fD_gain * (ierr[4] - iold[4]) / fDELTA_T); //4,0のフォトリフレクタの値をつかう@ + fD_gain * (ierr[0] - iold[0]) / fDELTA_T)/2.0
    fPID_D_L = (fD_gain * (ierr[3] - iold[3]) / fDELTA_T); //3,0のフォトリフレクタの値をつかう@ + fD_gain * (ierr[0] - iold[0]) / fDELTA_T)/2.0

    pwm_r = -fPID_P_R - fPID_D_R;//右モータのPWM値//(白から黒)-,-(黒から白)
    pwm_l = -fPID_P_L - fPID_D_L;//左モータのPWM値//(白から黒)-,-(黒から白)

    if (pwm_r >= 100) {
      pwm_r = 100;
    }
    if (pwm_l >= 100) {
      pwm_l = 100;
    }
    if (pwm_r <= 50) {
      pwm_r = 50;
    }
    if (pwm_l <= 50) {
      pwm_l = 50;
    }
    break;



  case 2://後退して位置を調整する

    //      for (int i = 5; i < 7; i++) { //白→白を保つために白(ierrが正)だったら零にする
    //        if (ierr[i] > 0) {
    //          ierr[i] = 0;
    //          iold[i] = 0;
    //        }
    //      }

    fPID_P_R = fP_gain * ierr[4]; //4,6,0のフォトリフレクタの値をつかう@(fP_gain * ierr[4] + fP_gain * ierr[0])/2.0
    if (ierr[6] > 0) {
      fPID_P_R = (fPID_P_R +  fP_gain * ierr[6]) / 2.0;
    }
    fPID_P_L = fP_gain * ierr[3]; //3,5,0のフォトリフレクタの値をつかう@(fP_gain * ierr[3] + fP_gain * ierr[0])/2.0
    if (ierr[5] > 0) {
      fPID_P_L = (fPID_P_L + fP_gain * ierr[5]) / 2.0;
    }
    fPID_D_R = (fD_gain * (ierr[4] - iold[4]) / fDELTA_T); //4,0のフォトリフレクタの値をつかう@ + fD_gain * (ierr[0] - iold[0]) / fDELTA_T)/2.0
    fPID_D_L = (fD_gain * (ierr[3] - iold[3]) / fDELTA_T); //3,0のフォトリフレクタの値をつかう@ + fD_gain * (ierr[0] - iold[0]) / fDELTA_T)/2.0

    pwm_r = fPID_P_R + fPID_D_R;//右モータのPWM値//(白から黒)+,+(黒から白)
    pwm_l = fPID_P_L + fPID_D_L;//左モータのPWM値//(白から黒)+,+(黒から白)

    if (pwm_r >= -50) {
      pwm_r = -50;
    }
    if (pwm_l >= -50) {
      pwm_l = -50;
    }
    if (pwm_r <= -100) {
      pwm_r = -100;
    }
    if (pwm_l <= -100) {
      pwm_l = -100;
    }
    //linestop_frag = 1;
    break;


  default://modeが該当しない
    break;
  }



  switch (imode_turn) { //回転動作に関するスイッチケース文
  case 1://90度右回転

    //if(bcorrection_frag==0){
    //bcorrection_frag=1;
    //}


    /*
     fPID_P_R = (-ierr[2] * fP_gain - (iberr[1]) * fP_gain) / 2; //4,2を使う
     fPID_P_L = (ierr[1] * fP_gain + (iberr[0]) * fP_gain) / 2; //3,1を使う
     
     //fPID_D_R = -((fD_gain * (ierr[4] - iold[4]) / fDELTA_T) + fD_gain * (iberr[2] - ibold[2]) / fDELTA_T) / 2; //4,2を使う
     fPID_D_L = ((fD_gain * (ierr[3] - iold[3]) / fDELTA_T) + fD_gain * (iberr[1] - ibold[1]) / fDELTA_T) / 2; //3,1を使う
     
     pwm_l = -(ispeed * 3 / 4 + fPID_P_L + fPID_D_L) / 3.75; //(白から黒)+,+(黒から白)/ 2.75
     pwm_r = -pwm_l; //(白から黒)-,+,+(黒から白)逆にした 12/21,pwm_r=-pwm_lにした pwm_r = (fPID_P_L + fPID_D_L) / 5;
     
     
     if (pwm_r <= 100) {
     pwm_r = 100;
     }
     if (pwm_l <= -100) {
     pwm_l = -100;
     }
     */
    break;

  case 2://左折,90度左回転?する
    break;
    /*
      if (linestop_frag == 1) {
     motor_set(0, 0);
     delay(10);
     linestop_frag = 0;
     }
     fPID_P_R = (ierr[2] * fP_gain + (iberr[1]) * fP_gain) / 2; //4,2を使う
     fPID_P_L = fPID_P_R;//(-ierr[1] * fP_gain - (iberr[0]) * fP_gain) / 2; //3,1を使う
     
     fPID_D_R = ((fD_gain * (ierr[4] - iold[4]) / fDELTA_T) + fD_gain * (iberr[2] - ibold[2]) / fDELTA_T) / 2; //4,2を使う
     fPID_D_L = fPID_P_R;//-((fD_gain * (ierr[3] - iold[3]) / fDELTA_T) + fD_gain * (iberr[1] - ibold[1]) / fDELTA_T) / 2; //3,1を使う
     
     pwm_r = (ispeed + fPID_P_R + fPID_D_R); //(白から黒)+,+,+(黒から白)逆にした
     pwm_l = -(fPID_P_L + fPID_D_L); //(白から黒)+,+(黒から白)
     
     if (pwm_r >= 100) {
     pwm_r = 100;
     } else if (pwm_r <= 45) {
     pwm_r = 45;
     }
     if (pwm_l <= -100) {
     pwm_l = -100;
     }
     break;
     */

  case 3://右折,90度右回転?する
    /*
        fPID_P_R = (-ierr[2] * fP_gain - (iberr[1]) * fP_gain) / 2; //4,2を使う
     fPID_P_L = (ierr[1] * fP_gain + (iberr[0]) * fP_gain) / 2; //3,1を使う
     
     fPID_D_R = -((fD_gain * (ierr[4] - iold[4]) / fDELTA_T) + fD_gain * (iberr[2] - ibold[2]) / fDELTA_T) / 2; //4,2を使う
     fPID_D_L = ((fD_gain * (ierr[3] - iold[3]) / fDELTA_T) + fD_gain * (iberr[1] - ibold[1]) / fDELTA_T) / 2; //3,1を使う
     
     pwm_r = -(fPID_P_L + fPID_D_L) / 5; //(白から黒)+,+,+(黒から白)逆にした
     pwm_l = (ispeed * 3 / 4 + fPID_P_R + fPID_D_R) / 2.75; //(白から黒)+,+(黒から白)
     
     if (pwm_r <= -100) {
     pwm_r = -100;
     }
     if (pwm_l <= 100) {
     pwm_l = 100;
     }
     */
    break;


  default://modeが該当しない
    break;
  }
  vel_ctrl_set((pwm_r/255.0)*50.0, (pwm_l/255.0)*50.0);
  motor_set(pwm_r, pwm_l);//pwm_l, pwm_rこれが本来のモーセット?(直進がうまくいったときはこの逆にしてた)
}




