/*
  auther : keiya watanabe
  for use :正面補正
*/
double kp_ls = 0.1;
double ki_ls = 0.01;
double kd_ls = 0.0;
double ki_ls_add = 0.1;

double line_err_r = 0.0;
double line_err_l = 0.0;
double sum_line_err_r = 0.0;
double sum_line_err_l = 0.0;
double line_err_r_old = 0.0;
double line_err_l_old = 0.0;
int pwml = 0;
int pwmr = 0;

int line_reset_execute(){
  photoreflector();
  line_err_r = ithreshold[4] - inow[4];
  line_err_l = ithreshold[3] - inow[3];
  
  if(abs(sum_line_err_r + line_err_r) < 50)sum_line_err_r += line_err_r * ki_ls_add;
  if(abs(sum_line_err_l + line_err_l) < 50)sum_line_err_l += line_err_l * ki_ls_add;
  
  pwml = line_err_l * kp_ls + sum_line_err_l * ki_ls + (line_err_l - line_err_l_old) * kd_ls;
  pwmr = line_err_r * kp_ls + sum_line_err_r * ki_ls + (line_err_r - line_err_r_old) * kd_ls;
 
  //motor_set(pwml,pwmr); 
  vel_ctrl_set(pwml,pwmr);
  
  line_err_r_old = line_err_r;
  line_err_l_old = line_err_l;
}




/*
  Parcle's linetrace and recovery linetrace program
  auther : 真木祐弥


//#include "define.h"

const int ispeed = 0;//機体の進む速度(pwm値)
float fP_gain = 0;//pゲイン
float fD_gain = 0;//ｄゲイン

int iwhite = 0;
int iblack = 0;
int ithreshold = (iwhite + iblack) / 2; //ライントレースの閾値
int ierr[7];//閾値と今のフォトリフレクタの値の差
int inow[7];//フォトリフレクタから得た今の値
int iold[7];//ひとつ前のフォトリフレクタの値

float fPID_P_R = 0; //Pゲインの右モータに干渉する値
float fPID_P_L = 0; //Pゲインの左モータに干渉する値
float fPID_D_R = 0; //Dゲインの右モータに干渉する値
float fPID_D_L = 0; //Dゲインの左モータに干渉する値

int iDELTA_T = 1; //フォトリフレクタで値を読む頻度[msec]

void linetrace_open() {
  pinMode(PIN_FRF_0, INPUT);
  pinMode(PIN_FRF_1, INPUT);
  pinMode(PIN_FRF_2, INPUT);
  pinMode(PIN_FRF_3, INPUT);
  pinMode(PIN_FRF_4, INPUT);
  pinMode(PIN_FRF_5, INPUT);
  pinMode(PIN_FRF_6, INPUT);
  pinMode(PIN_PWM_L, OUTPUT);
  pinMode(PIN_PWM_R, OUTPUT);
}

void photoreflector() { //フォトリフレクタの値を読んで、閾値との差を計算する
  inow[0] = analogRead(PIN_FRF_0);
  inow[1] = analogRead(PIN_FRF_1);
  inow[2] = analogRead(PIN_FRF_2);
  inow[3] = analogRead(PIN_FRF_3);
  inow[4] = analogRead(PIN_FRF_4);
  inow[5] = analogRead(PIN_FRF_5);
  inow[6] = analogRead(PIN_FRF_6);
  for (int i = 0; i < 7; i++) {
    iold[i] = ierr[i];
    ierr[i] = ithreshold - inow[i];
  }
}

int linetrace_start(void) {
  photoreflector();//フォトリフレクタ関連の動作(上記)をおこなう
  //PD制御でライントレースする
  fPID_P_R = fP_gain * ierr[1]; //1,4のフォトリフレクタの値をつかう
  if (ierr[4] > ithreshold) { //白線を4番のフォトリフレクタが踏んだら
    fPID_P_R = (fPID_P_R + 2 * fP_gain * ierr[4]) / 3;
  }
  fPID_P_L = fP_gain * ierr[2]; //2,3のフォトリフレクタの値をつかう
  if (ierr[3] > ithreshold) { //白線を3番のフォトリフレクタが踏んだら
    fPID_P_L = (fPID_P_L + 2 * fP_gain * ierr[3]) / 3;
  }
  fPID_D_R = (-fD_gain * (ierr[2] - iold[2]) / iDELTA_T + 2 * fD_gain * (ierr[3] - iold[3]) / iDELTA_T) / 3; //2,3のフォトリフレクタの値をつかう
  fPID_D_L = (-fD_gain * (ierr[1] - iold[1]) / iDELTA_T + 2 * fD_gain * (ierr[4] - iold[4]) / iDELTA_T) / 3; //1,4のフォトリフレクタの値をつかう
  pwm_r = ispeed - fPID_P_R - fPID_D_R;//右モータのPWM値
  pwm_l = ispeed - fPID_P_L - fPID_D_L;//左モータのPWM値
  delay(iDELTA_T);
}

int linetrace_restart(void) { //ライントレースへの復帰動作
  photoreflector();
  if (ithreshold < inow[0] ){ //0番のフォトリフレクタがラインに綺麗にのっているかを確認
  }
  if (ithreshold > inow[1] && ithreshold > inow[5]) { //機体全体が左にずれている際に補正する
      fPID_P_R = fP_gain * ierr[1] / 2; //右に曲がってラインから外れないようにする
      fPID_P_L = fP_gain * ierr[2] / 2;
      fPID_D_R = fD_gain * (ierr[1] - iold[1]) / (iDELTA_T * 2);
      fPID_D_L = fD_gain * (ierr[2] - iold[2]) / (iDELTA_T * 2);
      pwm_r = ispeed / 4 + fPID_P_R + fPID_D_R; //右モータのPWM値
      pwm_l = -fPID_P_L - fPID_D_L;//左モータのPWM値
      delay(iDELTA_T);

    } else if (ithreshold > inow[2] && ithreshold > inow[6]) { //機体全体が右にずれている際に補正する
      fPID_P_R = fP_gain * ierr[1] / 2; //左に曲がってラインから外れないようにする
      fPID_P_L = fP_gain * ierr[2] / 2;
      fPID_D_R = fD_gain * (ierr[1] - iold[1]) / (iDELTA_T * 2);
      fPID_D_L = fD_gain * (ierr[2] - iold[2]) / (iDELTA_T * 2);
      pwm_r = -fPID_P_R - fPID_D_R;//右モータのPWM値
      pwm_l = ispeed / 4 + fPID_P_L + fPID_D_L; //左モータのPWM値
      delay(iDELTA_T);
    }
  }
  else if (inow[3] >= ithreshold) { //右に曲がってラインから外れないようにする
  fPID_P_R = fP_gain * ierr[3] / 2;
    fPID_P_L = fP_gain * ierr[4] / 2;
    fPID_D_R = fD_gain * (ierr[3] - iold[3]) / (iDELTA_T * 2);
    fPID_D_L = fD_gain * (ierr[4] - iold[4]) / (iDELTA_T * 2);
    pwm_r = ispeed / 4 + fPID_P_R + fPID_D_R; //右モータのPWM値
    pwm_l = -fPID_P_L - fPID_D_L;//左モータのPWM値
    delay(iDELTA_T);
  }
  else if (inow[4] >= ithreshold) { //左に曲がってラインから外れないようにする
  fPID_P_R = fP_gain * ierr[3] / 2;
    fPID_P_L = fP_gain * ierr[4] / 2;
    fPID_D_R = fD_gain * (ierr[3] - iold[3]) / (iDELTA_T * 2);
    fPID_D_L = fD_gain * (ierr[4] - iold[4]) / (iDELTA_T * 2);
    pwm_r = -fPID_P_R - fPID_D_R;//右モータのPWM値
    pwm_l = ispeed / 4 + fPID_P_L + fPID_D_L; //左モータのPWM値
    delay(iDELTA_T);
  }
}
*/
