//#include "define.h"
//#include "arm_ctrl.h"

void get_deg_arm() { //電圧からアームの回転角を決定する。
  v_value = analogRead(PIN_CHR);//A/D変換
  v_out = v_value * 5.0 / 1024.0;//可変抵抗の出力電圧
  arm_voltage = (v_out / v_in) * 100; //可変抵抗の電圧増幅度
  deg_arm = -(3.0 * ((arm_voltage + 7.5) / 1.15)) + 130; //アームの角座標(0~120[deg])
  //deg_arm = 3.0 * (107.5 - arm_voltage)/1.15;
  deg_arm_r = (PI / 180.0) * deg_arm; //deg→rad変換
  //return deg_arm;
}

double get_height() { //アームの角座標から洗浄位置の高さを求める
  get_deg_arm();
  deg_arm_r = (PI / 180.0) * deg_arm;
  height = Al * sin(deg_arm_r) + Ah;
  return height;
}
static double adjast = 0.0;
double get_adjast(double max_height) {
  get_height();
  double adjast_dist[2] = {0, 0};
  adjast_dist[0] = Al * cos(asin((height - Ah) / Al));
  adjast_dist[1] = Al * cos(asin((max_height - Ah) / Al));
  adjast = adjast_dist[0] - adjast_dist[1];
  //adjast = sqrt(pow(Al, 2) - pow((Ah - height), 2)) + A_s;//逆運動方程式
  
  
  return adjast;
}

double get_body_dist(double ref_height ) { //
  
  double body_dist = sqrt(pow(Al, 2) - pow((Ah - ref_height), 2));
  //*body_a_dist = Al * cos(PI / 3 - deg_arm_r);
  return body_dist;
}

void get_ud() {
  //ここからARM_PIDについて
  deg_m = (420 - deg_arm) / 2;
  deg_m_r = (PI / 180.0) * deg_m; //deg to rad

  ud1 = -(Ax * cos(deg_m_r) - Ay * sin(deg_m_r)); //udの第一項
  ud2 = sqrt(pow(Ax * cos(deg_m_r) - Ay * sin(deg_m_r), 2) - (pow(Ax, 2) + pow(Ay, 2) - pow(A_s, 2))); //udの第二項
  ud = ud1 + ud2;//逆運動学から求めた昇降軸の変位
  //(これは)解の公式から求めたものである。udは非負な変数なためud2の符号は+に定まる。
}
