

static run_state_t run_state = STP;
static double speed_ref  = 0.0;
static double speed_curr = 0.0;

static double dist_ref   = 0.0;
static double dist_curr  = 0.0;
static double  dist_err = 0.0;
static double dist_prev = 0.0;

static double deg_ref    = 0.0;
static double deg_curr   = 0.0;
static double height_ref_r = 0.0;
static double height_curr_r = 0.0;
//static double body_ref   = 0.0;
//static double body_curr  = 0.0;
static double er  = 0.0 , er_d = 0.0 ;
static double er_sum  = 0.0;
static double er_prev  = 0.0;
static int c = 0;
static double way_dist = 0.0;
double vel_ref;
double vel_mod;
double sign;
double ratio;

bool first_enter_LNT_flag = 1;


void run_ctrl_execute() {
  // 直進制御において減速を開始する距離 [cm]
  const double dist_vel_down = 0.0;

  // 回転制御において減速を開始する角度 [deg]
  const double angle_vel_down = 0.0;

  // 直進制御における左右のタイヤの距離差の補正ゲイン
  const double Ks_p = 8.0 ; // 40.0
  const double Ks_i =  0.0 ; // 0.2  1.0
  const double Ks_d = 80.0 ; // 50.0  20.0  5.0



    const double pres_Kp = 0.8;
  const double pres_Kd = 0.5;
  double pres_err = 0.0;
  double pres_err_prev = 0.0;

  // 回転制御における左右のタイヤの距離差の補正ゲイン
  const double Kr = 0.0;


  double d_l, d_r, d_a, v_l, v_r, h_r ; //vel_modratio
  pressure_get();

  //pres_err = (pres_val_ul - pres_val) / 20.0;

  // 負の指令値に対応
  if (dist_ref >= 0.0) {
    sign = 1;
  } 
  else sign = -1;
  //if (pres_val > pres_val_ul)sign = -1;
  //  if (pres_val - pres_val_ul > 20) {
  //    sign = sign * -1;
  //  } else {
  //    sign = sign * (pres_Kp * pres_err + pres_Kd * (pres_err - pres_err_prev));
  //  }
  //  pres_err_prev = pres_err;
  // } else if (pres_val > pres_val_ul) {
  //sign = -1;
  //
  //  }else{sign = -1;}

  //////////////////////////////////////////////////////////////////////////////////////

  distance_get(&d_l, &d_r);//左右のタイヤのPID制御や減速で使う値
  vel_ctrl_get(&v_l, &v_r);//
  //deg_ctrl_a_get(&d_a);
  height_ctrl_get(&d_a);
  get_deg_arm();

  //////////////////////////////////////////////////////////////////////////////

  switch (run_state) {
  case STP:
    //Serial.println("おわり");//vel_ctrl_resetいれちゃだめ
    vel_ctrl_set(0.0, 0.0);
    motor_a_set(0);
    //height_ctrl_set(0.0, 0.0 , 0.0);
    motor_set(0, 0);
    //encoder_reset();
    break;
  case STR:
    // 直進距離
    dist_curr  = (d_l + d_r) / 2.0;
    speed_curr = (v_l + v_r) / 2.0 * sign;

    // 減速率
    ratio = sign * (dist_ref - dist_curr) / dist_vel_down;
    if (ratio < 0.0) ratio = 0.0;
    if (ratio > 1.0) ratio = 1.0;

    if (speed_ref == 0.0 || dist_ref == 0.0 || ratio == 0.0 || pres_val > 20 ) { //|| ratio == 0.0|| pres_val > pres_val_ul
      encoder_reset();
      pwm_r = 0;
      pwm_l = 0;
      motor_set(pwm_r, pwm_l);
      /*if(LNT_frag == 0){
       run_state = STP;
       }else{
       run_state = LNT;
       }
       */
      run_state = STP;
      vel_ctrl_set(0.0, 0.0);
    } 
    else {
      // 減速の実行
      vel_ref = sign * speed_ref * ratio ;//;

      // 左右のタイヤの距離差の補正
      er = d_l - d_r;
      er_sum += er;
      er_d = er - er_prev;
      vel_mod = Ks_p * er + Ks_i * er_sum  + Ks_d  * er_d ;
      er_prev = er;

      vel_ctrl_set((vel_ref - vel_mod), (vel_ref + vel_mod));

    }

    break;
  case ROT:
    // 回転角度
    dist_curr  = -(d_l - d_r) / D_TIRE * 180.0 / PI;
    speed_curr = -(v_l - v_r) / D_TIRE * 180.0 / PI * sign;

    // 減速率
    ratio = sign * (dist_ref - dist_curr) / angle_vel_down;
    if (ratio < 0.0) ratio = 0.0;
    if (ratio > 1.0) ratio = 1.0;

    if (speed_ref == 0.0 || dist_ref == 0.0 || ratio == 0.0) {
      /*if(LNT_frag == 0){
       run_state = STP;
       }else{
       run_state = LNT;
       }*/
       
      encoder_reset();
      pwm_r = 0;
      pwm_l = 0;
      motor_set(pwm_r, pwm_l);
      run_state = STP;
      vel_ctrl_set(0.0, 0.0);
    } 
    else {
      // 減速の実行＆角速度指令値→速度指令値に変換
      vel_ref = sign * speed_ref * ratio * D_TIRE / 2.0 * PI / 180.0;

      // 左右のタイヤの距離差の補正
      vel_mod = -(d_l + d_r) * Kr;

      vel_ctrl_set(-(vel_ref - vel_mod), (vel_ref + vel_mod));
    }

    break;
  case ARM:

    deg_ctrl_a_set(deg_ref);

    if (deg_ref - 1 < deg_arm && deg_arm < deg_ref + 1) {
      c ++;
      if (c > 10) {
        run_state = STP;
        deg_ctrl_a_reset();
      }
    }
    else {

      c = 0;
    }
    break;

  case ARM_PID:
    get_deg_arm();
    dist_curr  = (d_l + d_r) * 10 / 2.0;
    dist_err = -(dist_prev - dist_curr);

    ratio = sign * (dist_ref - dist_curr) / dist_vel_down;
    if (ratio < 0.0) ratio = 0.0;
    if (ratio > 1.0) ratio = 1.0;


    /*
            if (speed_ref == 0.0 || dist_ref == 0.0 || ratio == 0.0) { //dist_ref - 5 < dist_curr && dist_curr < dist_ref + 5 //abs(dist_ref) <= abs(dist_curr) || pres_val > pres_val_ul
     height_ctrl_set(0.0, 0.0 , 0.0);
     if (deg_ref_h - 0.5 <= deg_arm && deg_arm <= deg_ref_h + 0.5) {
     c ++;
     height_ctrl_set(0.0, 0.0 , 0.0);
     if (c > 20) {
     motor_set(0, 0);
     height_ctrl_reset();
     encoder_reset();
     run_state = STP;
     //height_ctrl_set(0.0, 0.0 , 0.0);
     
     }
     }
     else {
     c = 0;
     }
     
     
     } else {
     c = 0;
     
     //deg_ref = (dist_err / ( Al * sin(deg_curr * PI / 180))) * 180 / PI;
     //deg_ref = dist_err;//要確認Δθ→Δxの場合
     
     
     
     
     vel_ref = sign * speed_ref * ratio;
     
     // 左右のタイヤの距離差の補正
     er = d_l - d_r;
     er_sum += er;
     er_d = er - er_prev;
     vel_mod = Ks_p * er + Ks_i * er_sum  + Ks_d  * er_d ;
     er_prev = er;
     
     dist_prev = dist_curr;
     height_ctrl_set(dist_err, (vel_ref - vel_mod), (vel_ref + vel_mod));
     }
     */
    //////////////////////////////////////////////////////////////////////////////////////////////

    height_ctrl_set(height_ref, 0.0, 0.0);
    get_height();
    if (abs(height-height_ref) < 10 && abs(dist_curr_l_h + body_curr) < 1.0) {
      c ++;
      if (c > 10) {
        run_state = STP;
        height_ctrl_reset();
      }
    }
    else {

      c = 0;
    }



    break;

  case LNT:
    //photoreflector();
    dist_curr  = (d_l + d_r) / 2.0;
    ratio = way_dist - dist_curr;//get_add_dist_curr();
    if (ratio < 0.0) ratio = 0.0;
    if (ratio > 1.0) ratio = 1.0;
    //      if (ierrstop == 1) {
    //        pwm_r = 0;
    //        pwm_l = 0;
    //        motor_set(pwm_r, pwm_l);
    //        run_state = STP;//エラーを画面に表示?
    //      }
    if (ratio == 0.0) {
      pwm_r = 0;
      pwm_l = 0;
      motor_set(pwm_r, pwm_l);
      run_state = STP;//コースを走り切った後の停止。正常な動作
      //bcorrection_frag = 1;
      //first_enter_LNT_flag = 1;
      add_dist_curr = 0;
      encoder_reset();
    }
    /*
        if(dist_l>way_dist || dist_r>way_dist){
     pwm_r=0;
     pwm_l=0;
     run_state = STP;
     }
     */
    //motor_set(pwm_l, pwm_r);//11/27追加
    break;


    ///////////////////////////////////////////////////////////////////////
  case LNT_RS:
    line_reset_execute();
    if(abs(line_err_r)<=15 && abs(line_err_l)<=15){
      c++;
      if(c > 3){
        run_state = STP;
      }
    }
    else{
      c=0;
      sum_line_err_r = 0.0;
      sum_line_err_l = 0.0;
    }
    break;

  }
}
//run_ctrl_execute()はここまで

//slaveのcase文で以下の関数からrun_ctrlするか選択し、状態などを変数に入れる。
void run_ctrl_set(run_state_t state, double speed, double dist) {
  if(first_enter_LNT_flag == 1)add_dist_curr = 0;
  run_state = state;
  speed_ref = abs(speed);
  dist_ref = dist;
  if(state != ROT)getset_add_dist_curr();
  vel_ctrl_reset();
  //LNT_frag = 0;
  vel_ctrl_reset();
  er = 0;
  er_prev = 0;
  er_sum = 0;
}

void run_ctrl_get(run_state_t *state, double * speed, double * dist) {
  *state = run_state;
  *speed = speed_ref;//speed_curr;
  *dist = dist_curr;

}

//ここからARM
void arm_ctrl_set(run_state_t state, double speed, double dist) {
  run_state = state;
  speed_ref = abs(speed);
  deg_ref = asin((dist - Ah) / Al)*(180/PI);

  //vel_ctrl_reset();//リセット
  er = 0;
  er_prev = 0;
  er_sum = 0;
}
void arm_ctrl_get(run_state_t *state, double * speed, double * dist) {
  *state = run_state;
  *speed = speed_ref;//speed_curr;
  *dist = deg_curr;
}

//ここからAIM_PID
void body_ctrl_set(run_state_t state, double speed, double dist) {
  run_state = state;
  speed_ref = abs(speed);
  dist_ref = get_adjast(dist);//[mm];
  get_deg_arm();
  deg_ref_h = deg_arm;

  dist_curr   = 0.0;
  dist_prev = 0.0;
  pres_err = 0.0;
  pres_err_prev = 0.0;
  pres_err_sum = 0.0;

  get_height();
  height_ref_vari = height;
  height_ref = dist;//[mm];
  encoder_set(-get_body_dist(height_ref_vari) / 10);

  if (height_ref > height) {
    judge = 1;
  } 
  else {
    judge = 2;
  }

  er = 0;
  er_prev = 0;
  er_sum = 0;
}
void body_ctrl_get(run_state_t *state, double * speed, double * dist) {

  *state = run_state;
  *speed = speed_ref;//speed_curr;
  *dist = height_ref_r;

}

void linetrace_start(run_state_t state, double speed, double dist) {
  run_state = state;
  way_dist = dist;//way_distはライントレースするコースの長さ
  dist_curr = 0.0;
  encoder_reset();
  add_dist_curr = 0;
  //LNT_frag = 1;
  vel_ctrl_reset();

}


